*$ CREATE SOURCE.FOR
*COPY SOURCE
*
*=== source ===========================================================*
*
      SUBROUTINE SOURCE ( NOMORE )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2006      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     New source for FLUKA9x-FLUKA200x:                                *
*                                                                      *
*     Created on 07 january 1990   by    Alfredo Ferrari & Paola Sala  *
*                                                   Infn - Milan       *
*                                                                      *
*     Last change on 03-mar-06     by    Alfredo Ferrari               *
*                                                                      *
*  This is just an example of a possible user written source routine.  *
*  note that the beam card still has some meaning - in the scoring the *
*  maximum momentum used in deciding the binning is taken from the     *
*  beam momentum.  Other beam card parameters are obsolete.            *
*                                                                      *
*----------------------------------------------------------------------*
* 
c OUTPUT FILE:check.dat
c
c Modified 04 DEC 2007: COMMON /NOEMI/ to be shared with usrmed* 
c 
c Modified 04 DEC 2007: in order to write in check.dat also the fluxtime 
c                       value format 51 has been changed.
c
c Modified 27 MAR 2008: use of FLUKA mathematical function:
c              DOUBLE PRECISION FUNCTION DGAUSF ( FINTEG, XA, XB, EPSEPS )
c
c----------------------------------------------------------------------c
c
      INCLUDE '(BEAMCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(IOIOCM)'
      INCLUDE '(LTCLCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(SOURCM)'
      INCLUDE '(SUMCOU)'
*
      EXTERNAL fu
      COMMON /NOEMIFU/ par1,par2,par3,par4
*
      LOGICAL LFIRST
*
      INTEGER kk,atomicN,massN
c      REAL*8 xi,yi,zi,costx,costy,costz,enkin,enkintot
*
      INTEGER kkpart,ijpart
c      REAL*8 pmom,fluxtime
      
c      COMMON /NOEMI/ kkpart,ijpart,atomicN,massN,enkintot,pmom,fluxtime
      COMMON /NOEMI/ enkin,enkintot,pmom,xi,yi,zi,costx,costy,costz,
     &               fluxtime,kkpart,ijpart,atomicN,massN
*
C----------------------------------
* NTUPLES:
      PARAMETER (NNTUPLE=10)
      REAL*4 XTUP(nntuple) 
c----------------------------------
c
c----------------------------------
*
      SAVE LFIRST
      DATA LFIRST / .TRUE. /
*
*======================================================================*
*                                                                      *
*                 BASIC VERSION                                        *
*                                                                      *
*======================================================================*
      NOMORE = 0
*  +-------------------------------------------------------------------*
*  |  First call initializations:
      IF ( LFIRST ) THEN
*  |  *** The following 3 cards are mandatory ***
         TKESUM = ZERZER
         LFIRST = .FALSE.
         LUSSRC = .TRUE.
*  |  *** User initialization ***
* return message from first call:
      WRITE(LUNOUT,*)' '
      WRITE(LUNOUT,*)'*** PROT_MIN Version of Routine SOURCE called ...'
      WRITE(LUNOUT,*)' '
c------------------
c Parameter setting:
c------------------
c Geometric Factor:
      radius=7.1D+00 !sphere radius in cm (inside C - see input cards)
c      radius=8.0D+00 !sphere radius in cm (inside vacuum - see input cards)
      GF=4*(PIPIPI*PIPIPI)*((radius/100)**2) !sphere geometric factor[m**2 sr]
c------------------
c Protons:
      atomicN=1              !Atomic Number Z (integer) 1=protons
      massN=1                !Atomic Mass Number A (integer) 1=protons
c------------------
c Proton at solar minimum:
c Maximum and Minimum:
      emin=0.1D+00   ! minimum energy value in GeV/A
      emax=100.0D+00 ! maximum energy value in GeV/A
c Fit parameters:
      par1=18000.D+00
      par2=1.09D+00
      par3=3.66D+00
      par4=0.87D+00
c
      efmin=emax      ! from energy interval maximum
      efmax=(par4*par2)/(par3-par4) ! from derivative of f 
      fumin=fu(efmin)  ! function minimum at emax
      fumax=fu(efmax)  ! function maximum from derivative of f
c Integral:
c------------------
c DGAUSF error:
      error=0.001D+00
c
c      ab=DGAUSS(fu,emin,emax,error) !CERNLIB mathematical function
      ab=DGAUSF(fu,emin,emax,error) !FLUKA mathematical function
c------------------
c Set primary particle counter equal 0
      kk=0
c------------------
      WRITE(LUNOUT,*)' '
      WRITE(LUNOUT,*)'*** Checking ...'
      WRITE(LUNOUT,*)' '
c
      WRITE(LUNOUT,*)'Kinetic energy minimum = ',emin
      WRITE(LUNOUT,*)'Kinetic energy maximum = ',emax
      WRITE(LUNOUT,*)'  '
c
      WRITE(LUNOUT,*)'Kinetic energy fu minimum = ',efmin
      WRITE(LUNOUT,*)'Spectrum minimum value = ',fumin
      WRITE(LUNOUT,*)'Kinetic energy fu maximum = ',efmax
      WRITE(LUNOUT,*)'Spectrum maximum value = ',fumax
      WRITE(LUNOUT,*)'  '
c
      WRITE(LUNOUT,*)'Sphere radius = ',radius,'[cm]'
      WRITE(LUNOUT,*)'Geometrical factor = ',GF,'[m**2 sr]'
      WRITE(LUNOUT,*)' '
c
      WRITE(LUNOUT,*)'*** End checking'
      WRITE(LUNOUT,*)' '
c------------------
      END IF
*  |
*  +-------------------------------------------------------------------*
c------------------
      OPEN(12,
     +FILE=
     +'/lisa-pf/prova_lngs/check_fluka/'//
     +'check.dat',
     +status='unknown')
c------------------
c
* Sample an energy from the spectrum
* FLRNDM(XIIIDUMMY) get a random number in the interval [0.D+00,1.D+00)
c      XIIIDUMMY=costx !It is suggested to use the name of a variable which 
cc                     !has been recently modified.
c
c 23 Apr 2008 N. Finetti
c
 5    CONTINUE

c      XIIIDUMMY=XIII
c      YIIIDUMMY=YIII
c
c       XIII = emin+(emax-emin)*rndm(XIIIDUMMY)   ! CERNLIB RNDM
      XIII = emin+(emax-emin)*FLRNDM(XIIIDUMMY) ! FLUKA FLRNDM
      YFUNC=fu(XIII)
c      YIII = fumin+(fumax-fumin)*rndm(YIIIDUMMY)    ! CERNLIB RNDM
      YIII = fumin+(fumax-fumin)*FLRNDM(YIIIDUMMY) ! FLUKA FLRNDM
c
      IF(YIII.gt.YFUNC) GO TO 5
      kk=kk+1
      SAMPLE = XIII
c-----------------
c Sampling a random position and direction on an sphere of radius=radius:
       CALL SFLOOD(XXX,YYY,ZZZ,UXXX,VYYY,WZZZ)
       xi=radius*XXX
       yi=radius*YYY
       zi=radius*ZZZ
       costx=UXXX
       costy=VYYY
       costz=WZZZ
c-----------------
      fluxtime=kk/(GF*ab)
      kkcal=int(GF*ab*fluxtime)
      write(12,*)'    '
      write(12,*)' Sphere radius = ',radius,'[cm]'
      write(12,*)' Geometrical factor =',GF,'[m**2 sr]'
      write(12,*)' Integral of flux (fu) =',ab
      write(12,*)' Time =',fluxtime,'s'
      write(12,*)' int(GF*ab*fluxtime) =',kkcal
      write(12,*)' Energy range: ',emin,'  -',emax,' GeV(/n)'
      write(12,*)'    '
c------------------
      kkpart=kk
      ijpart=IJBEAM          !Incident particle type
      enkin=SAMPLE !sampled energy from the spectrum (15apr2008)
      enkintot=enkin*massN   !Total kinetic energy

c Ntuples:
               XTUP(1) = kkpart
               XTUP(2) = fluxtime
               XTUP(3) = enkin
               XTUP(4) = xi
               XTUP(5) = yi
               XTUP(6) = zi
               XTUP(7) = costx
               XTUP(8) = costy
               XTUP(9) = costz
               XTUP(10) = XIII
               CALL HFN(100,XTUP)      
cc

      WRITE(12,*)
     +' Event N., IJBEAM, Atomic N., Mass N., En.Kin./A, En.Kin.Tot., 
     +fluxtime'
      WRITE(12,51) kk,IJBEAM,atomicN,massN,enkin,enkintot,fluxtime
 51   FORMAT(i8,1x,i8,1x,i8,1x,i8,1x,1f10.3,1x,1f10.3,1x,f10.3)
      write(12,*)'    '
*  +-------------------------------------------------------------------*
*  Push one source particle to the stack. Note that you could as well
*  push many but this way we reserve a maximum amount of space in the
*  stack for the secondaries to be generated
* Npflka is the stack counter: of course any time source is called it
* must be =0
      NPFLKA = NPFLKA + 1
* Wt is the weight of the particle
      WTFLK  (NPFLKA) = ONEONE
      WEIPRI = WEIPRI + WTFLK (NPFLKA)
* Particle type (1=proton.....). Ijbeam is the type set by the BEAM
* card
*  +-------------------------------------------------------------------*
*  |  (Radioactive) isotope:
      IF ( IJBEAM .EQ. -2 .AND. LRDBEA ) THEN
         IARES  = IPROA
         IZRES  = IPROZ
         IISRES = IPROM
         CALL STISBM ( IARES, IZRES, IISRES )
         IJHION = IPROZ  * 1000 + IPROA
         IJHION = IJHION * 100 + KXHEAV
         IONID  = IJHION
         CALL DCDION ( IONID )
         CALL SETION ( IONID )
*  |
*  +-------------------------------------------------------------------*
*  |  Heavy ion:
      ELSE IF ( IJBEAM .EQ. -2 ) THEN
         IJHION = IPROZ  * 1000 + IPROA
         IJHION = IJHION * 100 + KXHEAV
         IONID  = IJHION
         CALL DCDION ( IONID )
         CALL SETION ( IONID )
         ILOFLK (NPFLKA) = IJHION
*  |  Flag this is prompt radiation
         LRADDC (NPFLKA) = .FALSE.
*  |
*  +-------------------------------------------------------------------*
*  |  Normal hadron:
      ELSE
         IONID = IJBEAM
         ILOFLK (NPFLKA) = IJBEAM
*  |  Flag this is prompt radiation
         LRADDC (NPFLKA) = .FALSE.
      END IF
*  |
*  +-------------------------------------------------------------------*
* From this point .....
* Particle generation (1 for primaries)
      LOFLK  (NPFLKA) = 1
* User dependent flag:
      LOUSE  (NPFLKA) = 0
* User dependent spare variables:
      DO 100 ISPR = 1, MKBMX1
         SPAREK (ISPR,NPFLKA) = ZERZER
 100  CONTINUE
* User dependent spare flags:
      DO 200 ISPR = 1, MKBMX2
         ISPARK (ISPR,NPFLKA) = 0
 200  CONTINUE
* Save the track number of the stack particle:
      ISPARK (MKBMX2,NPFLKA) = NPFLKA
      NPARMA = NPARMA + 1
      NUMPAR (NPFLKA) = NPARMA
      NEVENT (NPFLKA) = 0
      DFNEAR (NPFLKA) = +ZERZER
* ... to this point: don't change anything
* Particle age (s)
      AGESTK (NPFLKA) = +ZERZER
      AKNSHR (NPFLKA) = -TWOTWO
* Group number for "low" energy neutrons, set to 0 anyway
      IGROUP (NPFLKA) = 0
* Kinetic energy of the particle (GeV)
C      TKEFLK (NPFLKA) = SQRT ( PBEAM**2 + AM (IONID)**2 ) - AM (IONID)
      TKEFLK (NPFLKA) = enkintot
* Particle momentum
C      PMOFLK (NPFLKA) = PBEAM
c      PMOFLK (NPFLKA) = SQRT ( TKEFLK (NPFLKA) * ( TKEFLK (NPFLKA)
c     &                       + TWOTWO * AM (ILOFLK(NPFLKA)) ) )
      PMOFLK (NPFLKA) = SQRT ( TKEFLK (NPFLKA) * ( TKEFLK (NPFLKA)
     &                       + TWOTWO * AM (IONID) ) )
      pmom=PMOFLK (NPFLKA)

      write(12,*)' Particle mass (in SOURCE)=',AM (ILOFLK(NPFLKA))
      write(12,*)' Particle kin. en. (in SOURCE)=',TKEFLK (NPFLKA)
      write(12,*)' Particle momentum (in SOURCE)=',PMOFLK (NPFLKA)

* Cosines (tx,ty,tz)
C      TXFLK  (NPFLKA) = UBEAM
C      TYFLK  (NPFLKA) = VBEAM
C      TZFLK  (NPFLKA) = WBEAM
c*      TZFLK  (NPFLKA) = SQRT ( ONEONE - TXFLK (NPFLKA)**2
c*     &                       - TYFLK (NPFLKA)**2 )

      TXFLK  (NPFLKA) = costx
      TYFLK  (NPFLKA) = costy
      TZFLK  (NPFLKA) = costz
      write(12,*)'     '
      write(12,*)' Particle TXFLK (in SOURCE)=',TXFLK  (NPFLKA) 
      write(12,*)' Particle TYFLK (in SOURCE)=',TYFLK  (NPFLKA)
      write(12,*)' Particle TZFLK (in SOURCE)=',TZFLK  (NPFLKA)
      write(12,*)' TXFLK**2+TYFLK**2+TZFLK**2=',
     +(TXFLK  (NPFLKA))**2+(TYFLK  (NPFLKA))**2+(TZFLK  (NPFLKA))**2
      write(12,*)'     '

* Polarization cosines:
      TXPOL  (NPFLKA) = -TWOTWO
      TYPOL  (NPFLKA) = +ZERZER
      TZPOL  (NPFLKA) = +ZERZER
* Particle coordinates
C      XFLK   (NPFLKA) = XBEAM
C      YFLK   (NPFLKA) = YBEAM
C      ZFLK   (NPFLKA) = ZBEAM
       XFLK   (NPFLKA) = xi
       YFLK   (NPFLKA) = yi
       ZFLK   (NPFLKA) = zi

       CLOSE(12)

*  Calculate the total kinetic energy of the primaries: don't change
      IF ( ILOFLK (NPFLKA) .EQ. -2 .OR. ILOFLK (NPFLKA) .GT. 100000 )
     &   THEN
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      ELSE IF ( ILOFLK (NPFLKA) .NE. 0 ) THEN
         TKESUM = TKESUM + ( TKEFLK (NPFLKA) + AMDISC (ILOFLK(NPFLKA)) )
     &          * WTFLK (NPFLKA)
      ELSE
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      END IF
      RADDLY (NPFLKA) = ZERZER
*  Here we ask for the region number of the hitting point.
*     NREG (NPFLKA) = ...
*  The following line makes the starting region search much more
*  robust if particles are starting very close to a boundary:
      CALL GEOCRS ( TXFLK (NPFLKA), TYFLK (NPFLKA), TZFLK (NPFLKA) )
      CALL GEOREG ( XFLK  (NPFLKA), YFLK  (NPFLKA), ZFLK  (NPFLKA),
     &              NRGFLK(NPFLKA), IDISC )
*  Do not change these cards:
      CALL GEOHSM ( NHSPNT (NPFLKA), 1, -11, MLATTC )
      NLATTC (NPFLKA) = MLATTC
      CMPATH (NPFLKA) = ZERZER
      CALL SOEVSV
      RETURN
*=== End of subroutine Source =========================================*
      END
******* External function fu ******************************************
       FUNCTION fu(x)
       REAL*8 fu
       REAL*8 x
       REAL*8 par1,par2,par3,par4
       COMMON /NOEMIFU/ par1,par2,par3,par4
c
         fu=par1*(x+par2)**(-par3)*x**par4
c       print*,'func in fuction',fu,' Energy=',x,' GeV/A'
       return
       end
***********************************************************************


